---
title: VRFrameData
slug: Web/API/VRFrameData
tags:
  - API
  - Experimental
  - Interface
  - Reference
  - VR
  - VRFrameData
  - Virtual Reality
  - WebVR
---
<div>{{APIRef("WebVR API")}}{{SeeCompatTable}}</div>

<p>The <strong><code>VRFrameData</code></strong> interface of the <a href="/en-US/docs/Web/API/WebVR_API">WebVR API</a> represents all the information needed to render a single frame of a VR scene; constructed by {{domxref("VRDisplay.getFrameData()")}}.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("VRFrameData.VRFrameData()")}}</dt>
 <dd>Creates a <code>VRFrameData</code> object instance.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("VRFrameData.leftProjectionMatrix")}} {{readonlyInline}}</dt>
 <dd>A {{domxref("Float32Array")}} representing a 4x4 matrix that describes the projection to be used for the left eye’s rendering.</dd>
 <dt>{{domxref("VRFrameData.leftViewMatrix")}} {{readonlyInline}}</dt>
 <dd>A {{domxref("Float32Array")}} representing a 4x4 matrix that describes the view transform to be used for the left eye’s rendering.</dd>
 <dt>{{domxref("VRFrameData.pose")}} {{readonlyInline}}</dt>
 <dd>The {{domxref("VRPose")}} of the {{domxref("VRDisplay")}} at the current {{domxref("VRFrameData.timestamp")}}.</dd>
 <dt>{{domxref("VRFrameData.rightProjectionMatrix")}} {{readonlyInline}}</dt>
 <dd>A {{domxref("Float32Array")}} representing a 4x4 matrix that describes the projection to be used for the right eye’s rendering.</dd>
 <dt>{{domxref("VRFrameData.rightViewMatrix")}} {{readonlyInline}}</dt>
 <dd>A {{domxref("Float32Array")}} representing a 4x4 matrix that describes the view transform to be used for the right eye’s rendering.</dd>
 <dt>{{domxref("VRFrameData.timestamp")}} {{readonlyInline}}</dt>
 <dd>A constantly increasing timestamp value representing the time a frame update occurred.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>{{page("/Web/API/VRDisplay/getFrameData", "Examples")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebVR 1.1', '#interface-vrdisplayevent', 'VRDisplayEvent')}}</td>
   <td>{{Spec2('WebVR 1.1')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.VRFrameData")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebVR_API">WebVR API homepage</a></li>
 <li><a href="http://mozvr.com/">MozVr.com</a> — demos, downloads, and other resources from the Mozilla VR team.</li>
</ul>
